<div class="container-fluid">
  <div class="card">
    <div class="card-header bg-info">
      <div class="row">
        <div class="col-sm-6">
          Branch Budget Detail
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs fa-pull-right"
                  (click)="addEditBranchBudget('Add', null)">
            Add New Branch Budget
          </button>
        </div>
      </div>
    </div>
    <div class="card-header bg-light">
      <div class="row">
        <div class="col-sm-2">
          <div class="form-group">
            <label for="fiscalYearId">Fiscal Year</label>
            <select id="fiscalYearId"
                    class="form-control"
                    [(ngModel)]="fiscalYearId"
                    name="fiscalYearId">
              <option *ngFor="let event of (fiscalYears); let i = index"
                      [ngValue]="(fiscalYears)[i].id"
              >{{(fiscalYears)[i].year }}</option>
            </select>
          </div>
        </div>
        <div class="col-sm-3">
          <div class="form-group">
            <label for="branch">Branch</label>
            <select id="branch"
                    class="form-control"
                    [(ngModel)]="branchId"
                    name="expType">
              <option *ngFor="let event of (branches); let i = index"
                      [ngValue]="(branches)[i].branchId"
              >{{(branches)[i].name }}</option>
            </select>
          </div>
        </div>
        <div class="col-sm-2">
          <div class="form-group">
            <label for="accountHeadId">Account Head</label>
            <select id="accountHeadId"
                    class="form-control"
                    [(ngModel)]="accountHeadId"
                    name="expType">
              <option *ngFor="let event of (accountHeads); let i = index"
                      [ngValue]="(accountHeads)[i].accountHeadId"
              >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
            </select>
          </div>
        </div>
        <div class="col-sm-2">
          <div class="form-group">
            <label for="type">Quarter</label>
            <select id="type"
                    class="form-control"
                    [(ngModel)]="selectedQuarter"
                    name="requestedFor">
              <option *ngFor="let event of (allQuarters); let i = index"
                      [ngValue]="(allQuarters)[i].value"
              >{{(allQuarters)[i].key}}</option>
            </select>
          </div>
        </div>
        <div class="col-sm-3">
          <div class="form-group" style="margin-top: 27px">
            <button class=" btn btn-success" (click)="search()">Search</button> &nbsp;
            <button class=" btn btn-danger" (click)="reset()">Reset</button>
          </div>
        </div>
      </div>
    </div>
    <p-table id="exportTable"
             class="text-left"
             [columns]="columnName"
             [value]="(data$)"
             [resizableColumns]="true"
             [autoLayout]="true"
             [showCurrentPageReport]="true">

      <ng-template pTemplate="caption">
        List of Branch Budget Detail
        :&nbsp;{{ totalRecords }}
        <button class="btn btn-info btn-xs fa-pull-right"
                (click)="downloadExcel()">
          <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
          <i class="pi pi-file-excel" style="font-size: 1em;"></i>
          Download
        </button>
        <button class="btn btn-success btn-xs fa-pull-right"
                *ngIf="canTransferBudget"
                (click)="gotoBulkTransfer()">
          Transfer Bulk Budget
        </button>

      </ng-template>
      <ng-template pTemplate="header" let-columns>
        <tr>
          <th *ngFor="let col of columns" [pSortableColumn]="col.value">
            {{col.name}}
            <p-sortIcon [field]="col.value"></p-sortIcon>
          </th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-list let-i="rowIndex">
        <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
          <td>{{i + 1}}</td>
          <td>{{list.branchMiniResource.name + ' ( ' + list.branchMiniResource.code + ' )'}}</td>
          <td>{{list.fiscalYear}}</td>
          <td>{{list.month}}</td>
          <td>{{list.accountHead}}</td>
          <td>{{list.budgetAmount | currency : 'NPR '}}</td>
          <td>{{list.expenseTillDate | currency : 'NPR '}}</td>
          <td>{{list.preApprovedAmount | currency : 'NPR '}}</td>
          <td>
            <a (click)="addEditBranchBudget('Edit', list)"
               *ngIf="canTransferBudget">
              <button class="btn btn-xs  btn-success">
                Edit <i class="pi pi-check-square"></i>
              </button>
            </a>
            &nbsp;&nbsp;
            <a (click)="transferBudget(list)" *ngIf="canTransferBudget">
              <button class="btn btn-success btn-xs">
                Transfer
                <i class="pi pi-angle-double-right" style="font-size: 1rem"></i>
              </button>
            </a>
          </td>
        </tr>
      </ng-template>
    </p-table>
    <p-paginator
      [rows]="itemsPerPage"
      [totalRecords]="totalRecords"
      pageLinkSize="3"
      [rowsPerPageOptions]="rowsPerPageOptions"
      (onPageChange)="paginate($event)">
    </p-paginator>
  </div>
</div>


<p-dialog [(visible)]="display"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    {{title}} Branch Budget
  </p-header>
  <form [formGroup]="addEditBranchBudgetForm">
    <div class="row">
      <div class="col-sm-6">
        <div class="form-group">
          <label for="fiscalYear">Fiscal Year</label>
          <select id="fiscalYear"
                  class="form-control"
                  formControlName="fiscalYearId"
                  name="fiscalYear">
            <option *ngFor="let event of (fiscalYears); let i = index"
                    [ngValue]="(fiscalYears)[i].id"
            >{{(fiscalYears)[i].year }}</option>
          </select>
        </div>
        <div class="form-group">
          <label for="accountHead">Account Head</label>
          <select id="accountHead"
                  class="form-control"
                  formControlName="accountHeadId"
                  name="accountHead">
            <option *ngFor="let event of (accountHeads); let i = index"
                    [ngValue]="(accountHeads)[i].accountHeadId"
            >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
          </select>
        </div>
        <div class="form-group">
          <label for="subject">Budget</label>
          <input type="number"
                 class="form-control"
                 id="subject"
                 placeholder="Enter Budget Amount"
                 formControlName="budget"
                 required
          >
          <!--              <small id="subjectHelp" class="form-text text-muted">We'll never share your email with anyone else.</small>-->
        </div>
      </div>
      <div class="col-sm-6">
        <div class="form-group">
          <label for="branchId">Branch</label>
          <select id="branchId"
                  class="form-control"
                  formControlName="branchId"
                  name="branchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
        </div>

        <div class="form-group">
          <label for="month">Month</label>
          <select id="month"
                  class="form-control"
                  formControlName="month"
                  name="month">
            <option *ngFor="let event of (months); let i = index"
                    [ngValue]="(months)[i].months"
            >{{(months)[i].months }}</option>
          </select>
        </div>
      </div>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block" (click)="cancel()"> Cancel</button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  [disabled]="addEditBranchBudgetForm.invalid || loading"
                  (click)="submit()" type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>


<p-dialog [(visible)]="displayBudgetTransferForm"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    Transfer Budget
  </p-header>
  <form [formGroup]="budgetTransferForm">
    <div class="row">
      <div class="col-sm-6">
        <h3>From Branch Budget</h3>
        <div class="form-group">
          <label for="fromFiscalYearId">Fiscal Year</label>
          <select id="fromFiscalYearId"
                  class="form-control"
                  formControlName="fromFiscalYearId"
                  name="fromFiscalYearId">
            <option *ngFor="let event of (fiscalYears); let i = index"
                    [ngValue]="(fiscalYears)[i].id"
            >{{(fiscalYears)[i].year }}</option>
          </select>
        </div>
        <div class="form-group">
          <label for="fromMonth">Month</label>
          <select id="fromMonth"
                  class="form-control"
                  formControlName="fromMonth"
                  name="fromMonth">
            <option *ngFor="let event of (months); let i = index"
                    [ngValue]="(months)[i].months"
            >{{(months)[i].months }}</option>
          </select>
        </div>

        <div class="form-group">
          <label for="fromBranchId">Branch</label>
          <select id="fromBranchId"
                  class="form-control"
                  formControlName="fromBranchId"
                  name="fromBranchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
        </div>

        <div class="form-group">
          <label for="fromAccountHeadId">Account Head</label>
          <select id="fromAccountHeadId"
                  class="form-control"
                  formControlName="fromAccountHeadId"
                  name="fromAccountHeadId">
            <option *ngFor="let event of (accountHeads); let i = index"
                    [ngValue]="(accountHeads)[i].accountHeadId"
            >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
          </select>
        </div>
      </div>
      <div class="col-sm-6">
        <h3>To Branch Budget</h3>
        <div class="form-group">
          <label for="toFiscalYearId">Fiscal Year<span class="required">*</span></label>
          <select id="toFiscalYearId"
                  class="form-control"
                  formControlName="toFiscalYearId"
                  [ngClass]="{ 'is-invalid': submitted && f.toFiscalYearId.errors }"
                  name="toFiscalYearId">
            <option *ngFor="let event of (fiscalYears); let i = index"
                    [ngValue]="(fiscalYears)[i].id"
            >{{(fiscalYears)[i].year }}</option>
          </select>
          <div *ngIf="submitted && f.toFiscalYearId.errors" class="invalid-feedback">
            <div *ngIf="f.toFiscalYearId.errors.required">Fiscal Year is Required.</div>
          </div>
        </div>
        <div class="form-group">
          <label for="toMonth">Month<span class="required">*</span></label>
          <select id="toMonth"
                  class="form-control"
                  formControlName="toMonth"
                  [ngClass]="{ 'is-invalid': submitted && f.toMonth.errors }"
                  name="toMonth">
            <option *ngFor="let event of (months); let i = index"
                    [ngValue]="(months)[i].months"
            >{{(months)[i].months }}</option>
          </select>
          <div *ngIf="submitted && f.toMonth.errors" class="invalid-feedback">
            <div *ngIf="f.toMonth.errors.required">Month is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="toBranchId">Branch<span class="required">*</span></label>
          <select id="toBranchId"
                  class="form-control"
                  formControlName="toBranchId"
                  [ngClass]="{ 'is-invalid': submitted && f.toBranchId.errors }"
                  name="toBranchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
          <div *ngIf="submitted && f.toBranchId.errors" class="invalid-feedback">
            <div *ngIf="f.toBranchId.errors.required"> Branch is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="toAccountHeadId">Account Head<span class="required">*</span></label>
          <select id="toAccountHeadId"
                  class="form-control"
                  formControlName="toAccountHeadId"
                  [ngClass]="{ 'is-invalid': submitted && f.toAccountHeadId.errors }"
                  name="toAccountHeadId">
            <option *ngFor="let event of (accountHeads); let i = index"
                    [ngValue]="(accountHeads)[i].accountHeadId"
            >{{(accountHeads)[i].description + '( ' + (accountHeads)[i].accountNumber + ')' }}</option>
          </select>
          <div *ngIf="submitted && f.toAccountHeadId.errors" class="invalid-feedback">
            <div *ngIf="f.toAccountHeadId.errors.required">Account Head required.</div>
          </div>
        </div>
      </div>
    </div>
    <div class="form-group">
      <label for="amount">Budget<span class="required">*</span></label>
      <input type="number"
             class="form-control"
             id="amount"
             placeholder="Enter Amount to be Transferred"
             [ngClass]="{ 'is-invalid': submitted && f.amount.errors }"
             formControlName="amount"
             required
      >
      <div *ngIf="submitted && f.amount.errors" class="invalid-feedback">
        <div *ngIf="f.amount.errors.required">Amount to be transferred is required.</div>
      </div>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block"
                  (click)="cancelTransfer()"> Cancel
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  (click)="submitTransfer()"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Submit
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>

